/*************************************************************/
/* iTraceroute (part of iSPY) Project                        */
/* Copyright (c) 2008, Zheng Zhang, Purdue University        */
/*************************************************************/

// PP_TcpAck implements TCP ACK/RST probing.

#ifndef __PP_TCPACK_H__
#define __PP_TCPACK_H__

#include <string>
using namespace std;

#include "Common.h"

//Implement the concept Probe for Ping template
class PP_TcpAck // : public Probe
{
public:
    PP_TcpAck (uint32 destIP, uint16 destPort); //Dummyprobe if destIP==0, used for parsing packet only
    ~PP_TcpAck ();

    // send a TCP ACK to destIP:destPort
    void send (uint16 seq);

    // the replied packet must match destIP:destPort, unless this is a
    // Dummyprobe returns false if the packet is not a valid reply
    bool parse (char* rawIpPacket, int packet_len, uint16* seq);
    string info_str (void);
    
private:
    void create_raw_socket (int *sockd);
    
    int sockd_;
    uint16 destPort_, srcPort_;
    uint32 destIP_, srcIP_;
};


#endif

