/*************************************************************/
/* iTraceroute (part of iSPY) Project                        */
/* Copyright (c) 2008, Zheng Zhang, Purdue University        */
/*************************************************************/

#include <pthread.h>
#include <fstream>
#include <string>
#include <vector>
using namespace std;

#include "Common.h"

class TF_Mt {
public:
    TF_Mt (int con_thrds);
    void run (void);
private:
    virtual bool process_single_task (int thrd_ith, const string& cmd, string* output) = 0;
    virtual void send_output (const string& tag, const string& cmd, const string& output) = 0;
    virtual bool get_input (string *cmd, string *tag) = 0;
    virtual bool end_of_input () = 0;

    struct Slave_Thread_Arg {
        int thrd_ith;
        TF_Mt* this_ptr;
    };

    friend void* _run_slave_thread (void* arg);
    void slave_thread (int thrd_ith);

    pthread_mutex_t input_rlock, output_wlock;
    int con_thrds_;
};


class TF_MtFileBatch : public TF_Mt {
public:    
    TF_MtFileBatch (int con_thrds, ifstream* task_list_file);
private:
    ifstream* task_list_file_;
    void send_output (const string& tag, const string& cmd, const string& output);
    bool get_input (string *cmd, string *tag);
    bool end_of_input ();
};

